#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include <fcntl.h>
#include <unistd.h>

void search (char *path, char *mystring, int mysize) {

	DIR *dir;
	struct dirent *entry;

    /* ist Verzeichnis lesbar */
    if (!(dir = opendir(path))) {
		perror("opendir");
		exit(1);
    }

    /* alle Verzeichniseintraege durchlaufen ... */
    while ((entry = readdir(dir))) {

		struct stat statbuf;
		char buf[1024];
		char cont[101];
		int res;

		/* . und .. auslassen */
		if (!strcmp(entry->d_name, ".") || !strcmp(entry->d_name, ".."))
		    continue;

		/* Pfad zusammenbasteln */
		sprintf(buf, "%s/%s", path, entry->d_name);

		/* INode Information in statbuf einlesen */
		if (stat(buf, &statbuf) < 0) {
			fprintf(stderr, "CANNOT READ INFO OF %s\n", buf);
		}
		else { 
			/* falls Datei */
		    if ((statbuf.st_mode & S_IFMT)==S_IFREG) {		
				/* printf("Datei: %s\n", buf); */
				int fd;
				/* kann Datei geoeffnet werden */
				if ((fd = open(buf, O_RDONLY)) < 0) {
					perror("open()");
				} 
				else {

					/* Dateianfang */
					if ((res = read(fd, cont, mysize)) == mysize) {

						if (strncmp(mystring, cont, mysize) == 0) {
							printf("String %s am Anfang der Datei %s gefunden\n", cont, buf);
						}

					}

					/* Dateiende */
					lseek(fd, -mysize, SEEK_END);
					if ((res = read(fd, cont, mysize)) == mysize) {

						if (strncmp(mystring, cont, mysize) == 0) {
							printf("String %s am Ende der Datei %s gefunden\n", cont, buf);
						}
					}

					close(fd);
				}
			}
	 		/* falls Verzeichnis, dann rekursiv absteigen */
            if ((statbuf.st_mode & S_IFMT)==S_IFDIR) {
				/* printf("Verzeichnis: %s\n", buf); */
                search(buf, mystring, mysize);
            }
		}
	}
	closedir(dir);
}

int main(int argc, char **argv) {

	if (argc != 3) /* falsche Anzahl Argumente */
        printf("usage: %s path string\n", argv[0]),
        exit(1);
        
        int mysize = strlen(argv[2]);

	search(argv[1], argv[2], mysize);

	return 0;

}
